
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>一则优化案例 / iVAN</title>

    <meta name="description" content="一则优化案例 昨晚收到客服MM电话,一用户反馈数据库响应非常慢,手机收到load异常报警,登上主机后发现大量sql执行非常慢,有的执行时间超过了10s 优化点一: SELECT * FROM `sitevipdb`.`game_shares_buy_list` WHERE price&gt;='2.00′ ORDER BY tran_id DESC LIMIT 10; 表结构为: CREATE TABLE `game_shares_buy_list` ( `tran_id` int(10) unsigned  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">一则优化案例</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>昨晚收到客服MM电话，一用户反馈数据库响应非常慢，手机收到load异常报警，登上主机后发现大量sql执行非常慢，有的执行时间超过了10s<br />
优化点一：<br />
SELECT * FROM `sitevipdb`.`game_shares_buy_list` WHERE price&gt;=’2.00′ ORDER BY tran_id DESC LIMIT 10;<br />
表结构为：<br />
CREATE TABLE `game_shares_buy_list` (<br />
`tran_id` int(10) unsigned NOT NULL AUTO_INCREMENT,<br />
`………..’<br />
PRIMARY KEY (`tran_id`),<br />
KEY `ind_username` (`username`)<br />
) ENGINE=InnoDB AUTO_INCREMENT=3144200 DEFAULT CHARSET=utf8;<br />
执行计划：<br />
root@127.0.0.1 : sitevipdb 09:10:22&gt; explain SELECT * FROM `sitevipdb`.`game_shares_buy_list` WHERE price&gt;=’2.00′ ORDER BY tran_id DESC LIMIT 10;<br />
+—-+————-+———————-+——-+—————+———+———+——+——+————-+<br />
| id | select_type | table | type | possible_keys | key | key_len | ref | rows | Extra |<br />
+—-+————-+———————-+——-+—————+———+———+——+——+————-+<br />
| 1 | SIMPLE | game_shares_buy_list | index | NULL | PRIMARY | 4 | NULL | 10 | Using where |<br />
+—-+————-+———————-+——-+—————+———+———+——+——+————-+<br />
1 row in set (0.00 sec)<br />
分析该sql的执行计划，由于tran_id是表的主键，所以查询根据主键降序顺序扫描，这样就可以不用排序，<br />
然后在过滤条件price&gt;2.00的记录，看上去这个执行计划貌似非常好，如果查询扫描到了满足条件的10条记录，就会停止扫描；<br />
但是这里有个问题，如果表中有大量的记录是不符合2.00的，意味查询就需要扫描非常多的记录，才能找到符合条件的10条：<br />
root@127.0.0.1 : sitevipdb 09:17:23&gt; select price,count(*) as cnt from `game_shares_buy_list` group by price order by cnt desc limit 10;<br />
+——-+——-+<br />
| price | cnt |<br />
+——-+——-+<br />
| 1.75 | 39101 |<br />
| 1.68 | 38477 |<br />
| 1.71 | 34869 |<br />
| 1.66 | 34849 |<br />
| 1.72 | 34718 |<br />
| 1.70 | 33996 |<br />
| 1.76 | 32527 |<br />
| 1.69 | 27189 |<br />
| 1.61 | 25694 |<br />
| 1.25 | 25450 |<br />
可以看到表中有大量的记录不是2.00的，所以这个时候不能在根据主键顺序扫描，在过滤记录；<br />
那么是否需要在price建立一个索引：<br />
root@127.0.0.1 : sitevipdb 09:09:01&gt; select count(*) from `game_shares_buy_list` where price&gt;’2′;<br />
+———-+<br />
| count(*) |<br />
+———-+<br />
| 4087 |<br />
+———-+<br />
root@127.0.0.1 : sitevipdb 09:17:31&gt; select count(*) from `game_shares_buy_list` ;<br />
+———-+<br />
| count(*) |<br />
+———-+<br />
| 1572100 |<br />
从上面price的数据分布可以看出，price的分布相对还是比较集中的，如果在price建立索引，mysql也有可能认为由于需要回表的记录过多，<br />
同时需要额外的排序，而不选择在price上的索引：<br />
root@127.0.0.1 : sitevipdb 09:24:53&gt; alter table game_shares_buy_list add index ind_game_shares_buy_list_price(price);<br />
Query OK, 0 rows affected (5.79 sec)</p>
<p><a href="http://hidba.org/wp-content/uploads/2012/05/exp11.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGlkYmEub3JnL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDEyLzA1L2V4cDExLmpwZw==.jpg"></a></p>
<p>可以看到优化器虽然注意到了我们新加的索引，但是最终还是选择了primary来扫描；<br />
所以这个时候我们加上去的索引没有产生效果，数据库负载依然很高，如果强制走price上的索引，效果会这样：<br />
root@127.0.0.1 : sitevipdb 09:35:38&gt; SELECT * FROM `sitevipdb`.`game_shares_buy_list` WHERE price&gt;=’2.0′ ORDER BY tran_id DESC LIMIT 10;<br />
。。。。。<br />
10 rows in set (7.06 sec)</p>
<p>root@127.0.0.1 : sitevipdb 09:36:00&gt; SELECT * FROM `sitevipdb`.`game_shares_buy_list` force index(ind_game_shares_buy_list_price) WHERE price&gt;=’2.0′ ORDER BY tran_id DESC LIMIT 10;<br />
。。。。<br />
10 rows in set (1.01 sec)<br />
可以看到如果强制走索引，时间已经明显下降了，但是还是有些慢，能不能在快一点？其实我们需要扫描的记录只有10条，但查询在取得这10条记录的时候需要扫描大量无效的记录</p>
<p><a href="http://hidba.org/wp-content/uploads/2012/05/exp2.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGlkYmEub3JnL3dwLWNvbnRlbnQvdXBsb2Fkcy8yMDEyLzA1L2V4cDIuanBn.jpg"></a></p>
<p>怎么降低这个数据：其实只要改写一下sql就可以，我们先从索引中得到满足条件的10个id，在回表进行关联：<br />
root@127.0.0.1 : sitevipdb 09:44:45&gt; select * from game_shares_buy_list t1,<br />
-&gt; ( SELECT tran_id FROM sitevipdb.game_shares_buy_list WHERE price&gt;=’2.0′ ORDER BY tran_id DESC LIMIT 10) t2<br />
-&gt; where t1.tran_id=t2.tran_id;<br />
10 rows in set (0.00 sec)<br />
可以看到执行时间已经不在秒级别了，和客户电话沟通后，很愿意这样改写sql。</p>
<p>—这里看到是order by tran_id是要额外排序的，索引也可以这样来建立消除排序(tran_id,price)这样可以消除排序，同时可以利用order by desc/asc +limit M,N的优化。</p>
<p>优化点二：<br />
CREATE TABLE `game_session` (<br />
`session_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT <em>,<br />
`session_expires` int(10) unsigned NOT NULL DEFAULT ‘0’,<br />
`client_ip` varchar(16) DEFAULT NULL,<br />
`session_data` text,<br />
…………………….<br />
PRIMARY KEY (`session_id`)<br />
) ENGINE=InnoDB DEFAULT CHARSET=utf8;</em></p>
<p>查询为select `session_data`, `session_expires` from `game_session` where session_id=’xxx’出现大量等待情况<br />
同时该表的insert，也有等待的现象；<br />
可以看到这个表结构设计是有些问题的，咨询了客户后，可以改为下面结构：<br />
CREATE TABLE `game_session` (<br />
id int auto_increment,<br />
`session_id` varchar(30) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT <em>,<br />
`session_expires` int(10) unsigned NOT NULL DEFAULT ‘0’,<br />
`client_ip` varchar(16) DEFAULT NULL,<br />
`session_data` varchar(200),<br />
PRIMARY KEY (id),<br />
key ind_session_id(session_id,session_data, session_expires)<br />
) ENGINE=InnoDB DEFAULT CHARSET=utf8;</em></p>
<p>-新增自增主键id作为表的主键，这样对插入的性能提升是很好的，同时也降低了表主键的大小；<br />
-将session_data由text改为了varchar(200),咨询了客户后，这个字段可以不用大字段存储，同时有text改为了varchar，就可以冗余到索引中；<br />
由于查询可以使用覆盖索引来完成，所以将查询的3个字段冗余到索引中，查询通过索引完成，不用回表；</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 18:50:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>一则优化案例的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeOjOM.html" rel="bookmark">打造月3000返利站优化案例（三）用户体验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前段时间已经浅谈了打造月3000返利站优化案例(二)网站推广.打造月3000返利站优化案例-框架优化,接下来我们就简单来谈谈关于用户体验方面的调整.用户体验讲究从网站印象.网站功能.网站实用性.网站内容等综合因素来改善网站环境,提高用户体验,合理的推广与提高网站用户体验,是提高网站转换率(把流量转化为有效客户的比率)的重要因素.用户体验对于网站的pv.跳出率等都有很大的影响.今天笔者就以返利网站为例和大家一起分享有什么不足的还望指点一二. 互联网有成千上万的各种各样的网站.只要一个好的模式一出来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGqP7p.html" rel="bookmark">Android性能优化案例研究（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自 http://www.importnew.com/4065.html 译者前言:在Android性能优化案例研究(上)中,作者Romain Guy将Falcon Pro这款应用作为例子,通过Android现有的工具追踪和分析了其隐藏的性能问题(重绘).下篇作者将会带来如何解决此类问题的方法和思路. 去掉冗余的图层 为 了去掉重绘我们必须首先理解它从哪里产生的.这就轮到Hierarchy Viewer和Tracer for OpenGL大显身手的时候了.Hierarchy Viewer是AD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVNZ2Bz.html" rel="bookmark">SQLServer &CenterDot; 最佳实践 &CenterDot; SQL Server优化案例分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				title: SQLServer · 最佳实践 · SQL Server优化案例分享 author: 石沫 前端时间的视频分享,这里有同学文档总结下来: 请参考:https://yq.aliyun.com/articles/60119			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlLNdLM.html" rel="bookmark">《构建高可用VMware vSphere 5&period;X虚拟化架构》&mdash;&mdash;1&period;5 ESXi主机优化案例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 ESXi主机优化案例 1.5.1 使用大缓存RAID 5阵列提高硬盘读写速度 目前市面上 10000 转或 15000 转 SAS 硬盘的平均读写速度约为 150MB/S,使用多块15000转SAS硬盘,配合256MB或以上缓存阵列卡组成RAID 5阵列,平均读写速度可以达到200MB/S甚至更高的读写速度. 作者曾经在一个项目中使用DELL PERC 5/i的阵列卡(256MB缓存),配置8块15000转的SAS 146G的硬盘,组成RAID 5阵列,经过测试,读写速度可以达到平均40			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL557kz.html" rel="bookmark">MySQL优化案例系列-mysql分页优化&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通常,我们会采用ORDER BY LIMIT start, offset 的方式来进行分页查询.例如下面这个SQL: SELECT * FROM `t1` WHERE ftype=1 ORDER BY id DESC LIMIT 100, 10; 或者像下面这个不带任何条件的分页SQL: SELECT * FROM `t1` ORDER BY id DESC LIMIT 100, 10; 一般而言,分页SQL的耗时随着 start 值的增加而急剧增加,我们来看下面这2个不同起始值的分页SQL执行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3Zjw0z.html" rel="bookmark">MySQL下的RAND&lpar;&rpar;优化案例分析&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				众所周知,在MySQL中,如果直接 ORDER BY RAND() 的话,效率非常差,因为会多次执行.事实上,如果等值查询也是用 RAND() 的话也如此,我们先来看看下面这几个SQL的不同执行计划和执行耗时. 首先,看下建表DDL,这是一个没有显式自增主键的InnoDB表: [yejr@imysql]&gt; show create table t_innodb_random\G *************************** 1. row *************************			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Yqy6p.html" rel="bookmark">MySQL优化案例：半连接（semi join）优化方式导致的查询性能低下</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下是来自DBA+社群MySQL领域原创专家李海翔分享的MySQL优化案例,关于MySQL V5.6.x/5.7.x SQL查询性能问题.   专家简介   李海翔 网名:那海蓝蓝 DBA+社群MySQL领域原创专家 从事数据库研发.数据库测试与技术管理等工作10余年,对数据库的内核有深入研究,擅长于PostgreSQL和MySQL等开源数据库的内核与架构.现任职于Oracle公司MySQL全球开发团队,从事查询优化技术的研究和MySQL查询优化器的开发工作.著有&lt;数据库查询优化器的艺术&gt;一书			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mv7rXWp.html" rel="bookmark">打造月3000返利站优化案例（二）网站推广</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 SEO诊断 淘宝客 云主机 技术大厅 前几天已经发布是返利网站完整的优化案例的一框架优化篇(http://www.admin5.com/plus/view.php?aid=380035).由于工作原因所以拖了这么多天才抽空出来写续篇.网站推广部分是网站运营不可或缺的步骤.今天就结合笔者自身实践经历跟大家一起分享下经验! 第一步:打造好品牌词 前一篇已经分析过关键词了,网站选择关键词的就略过了.现在很多大型网站都整合了返利频道比如腾讯的qq返利.360fanli.有道fanli.电信18			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj291Zb.html" rel="bookmark">Mysql性能优化案例研究-覆盖索引和SQL&lowbar;NO&lowbar;CACHE&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				场景 产品中有一张图片表pics,数据量将近100万条,有一条相关的查询语句,由于执行频次较高,想针对此语句进行优化 表结构很简单,主要字段: 复制代码 代码如下: user_id 用户ID picname 图片名称 smallimg 小图名称 一个用户会有多条图片记录,现在有一个根据user_id建立的索引:uid,查询语句也很简单:取得某用户的图片集合: 复制代码 代码如下: select picname, smallimg from pics where user_id = xxx; 优化			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7WLnRz.html" rel="bookmark">seo热门词的优化案例： 关键词&OpenCurlyDoubleQuote;阀门&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天跟大家分享一个seo热门词的优化案例, 关键词&quot;阀门&quot;,google目前排名第二位,,先看下这个站自身的一些条件:这个站的域名是07年的,google的快照是六天前的,一般企业站基本上都是以周为更新单位的,程序语言是asp(但参数很短,比较有利),有制作http://www.aliyun.com/zixun/aggregation/12334.html&quot;&gt;网站地图,所有图片加了alt描述,网站打开速度一般,不过很稳定;这是我们拿到一个站后初步的查看,下面继续. 我们			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrqVWb.html" rel="bookmark" class="title">Photoshop制作梦幻小人国</a>
					<div>
						  有时候当我们转换新的视角,再加点创新,也许就能从平凡中找到不平凡.本期的国外精品翻译教程想表达的就是当自身如昆虫般大小,周边的世界将化身为奇妙的童话世界. 这里笔者还提到的一点就是家长与孩子之间的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkVZjM.html" rel="bookmark" class="title">C&num;&lpar;asp&period;net&rpar; Application&period;DoEvents&lpar;&rpar; 处理队列消息</a>
					<div>
						该方法可以处理当前队列的消息,比如一个for循环 5000次 向TextBox中追加文本,那肯定会假死一会儿的. 此时便可使用Application.DoEvents()来处理队列的信息. 简单说下使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYJE5p.html" rel="bookmark" class="title">使用 WordPress 的 10 个非常有用的 MySQL 查询</a>
					<div>
						  大多数使用 WordPress 搭建的网站,其后台都是 MySQL 数据库,经常我们需要定制 WordPress 的功能,这里我们列表 10 个最有用的 WordPress 的数据库查询,你需要一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwA65M.html" rel="bookmark" class="title">PS圆角矩形和图层样式制作高光download图标</a>
					<div>
						本教程主要使用Photoshop制作立体高光效果网页下载按钮,主要使用圆角矩形工具和图层样式打造一个高光下载按钮,下面让我们一起来学习吧. 先看效果图. 新建文档1280x1024像素,背景白色,建新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ5vob.html" rel="bookmark" class="title">PHP的FTP学习（一）</a>
					<div>
						By Vikram Vaswani Melonfire November 07, 2000    我们是一群PHP的忠实FANS,我们因各种不同的原因使用它-WEB站点的开发,画图,数据库的联接等 - ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBk8lb.html" rel="bookmark" class="title">Java 1&period;5新特性Enum的用法</a>
					<div>
						Enum是enumeration(列举)的简写形式,包含在java.lang包中.熟悉C,C++,C#,或Pascal人应该对列举有所了解,先看个例子: public enum Season { wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKNvyp.html" rel="bookmark" class="title">access数据库密码查看器怎么用？</a>
					<div>
						  access数据库密码查看器可以破解目前已知的各版本Access数据库密码,支持20位中英文密码的破解,支持批量数据库破解. 1.可以破解目前已知的各版本Access数据库密码. 2.支持20位中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2OQ1M.html" rel="bookmark" class="title">win7系统出现dns解析失败怎么办</a>
					<div>
						 我们可以通过清除dns缓存来解决问题,具体方法如下: 第一步:首先在开始菜单中以管理员身份运行命令提示符. 第二步:执行ipconfig /flushdns命令,当出现&quot;successfu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6Vodz.html" rel="bookmark" class="title">什么是超频 怎么实现CPU超频</a>
					<div>
						电脑的超频就是通过人为的方式将CPU.显卡等硬件的工作频率提高,让它们在高于其额定的频率状态下稳定 工作.以Intel P4C 2.4GHz的CPU为例,它的额定工作频率是2.4GHz,如果将工作频率 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGOZ1p.html" rel="bookmark" class="title">选购光电鼠标的四个要点</a>
					<div>
						  如何才能选购一款合适的光电鼠标呢?选购光电鼠标的时候需要注意什么呢?本文为您详细的解答 1.点击分辨率 一款鼠标性能高低的决定性因素,就在于其鼠标内部的解码装置所能辨认的每英寸长度内的点数,也就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOavY5M.html" rel="bookmark" class="title">sharepoint做数据的增删改查，统计</a>
					<div>
						问题描述 用户之前自己用excel表在维护他们的数据,还用到了excel的宏:实现简单的数据增删改和查询统计:但因为想多人同时编辑,也希望更好用的一点:找到我希望基于工厂的sharepoint实现此功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRdvvz.html" rel="bookmark" class="title">关于利用myeclipse开发基于xfire的webservice</a>
					<div>
						http://blog.csdn.net/peirenlei/article/details/1774523					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrYw9M.html" rel="bookmark" class="title">树结构控件：jQuery zTree</a>
					<div>
						[简介] zTree 是利用 JQuery 的核心代码,实现一套能完成大部分常用功能的 Tree 插件  兼容 IE.FireFox.Chrome 等浏览器  在一个页面内可同时生成多个 Tree 实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQqEZz.html" rel="bookmark" class="title">ios-在IOS上我想做一个调用自带地图，但又不显示地图，只要定位出详细地址的APP</a>
					<div>
						问题描述 在IOS上我想做一个调用自带地图,但又不显示地图,只要定位出详细地址的APP 因为我是新手,想自己做一个简单的APP,功能如下: 1.首页上,点击定位按钮(dwButton),能在一个XS( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrlLVM.html" rel="bookmark" class="title">07&period; Web大前端时代之：HTML5&plus;CSS3入门系列~H5 地理位置</a>
					<div>
						Web大前端时代之:HTML5+CSS3入门系列:http://www.cnblogs.com/dunitian/p/5121725.html 定位类型 IP 定位 优点 任何位置都可用 在服务器端处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWvoWp.html" rel="bookmark" class="title">CodeIgniter实现更改view文件夹路径的方法&lowbar;php实例</a>
					<div>
						控制view文件夹路径的代码:system/core/loader.php public function add_package_path($path, $view_cascade=TRUE) {  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwnOwp.html" rel="bookmark" class="title">oc NSString 方法中 替换方法</a>
					<div>
						问题描述 oc NSString 方法中 替换方法 oc NSString 方法中 NSString *string = @&quot;This is a const string&quot;; NS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWPAmp.html" rel="bookmark" class="title">android-新手！运行Android项目失败！adb问题！</a>
					<div>
						问题描述 新手!运行Android项目失败!adb问题! RT,昨天还可以运行出来今天就不行了.错误提示: 在网上找了一些文章,都是说adb的端口被占用,关掉占用程序然后重启Eclipse就可以了,可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoJJyb.html" rel="bookmark" class="title">求助： TrueTypeFont&period;class&comma;着急用~先谢了！，</a>
					<div>
						问题描述 ThesourceattachmentdoesnotcontainthesourceforthefileTrueTypeFont.class在做界面的时候一直提示这个错误,不知道怎么解决,希 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKX4Az.html" rel="bookmark" class="title">HBase源码分析之HRegionServer上MemStore的flush处理流程（一）</a>
					<div>
						        在&lt;HBase源码分析之HRegion上MemStore的flsuh流程(一)&gt;.&lt;HBase源码分析之HRegion上MemStore的flsuh流程(二)&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLk8np.html" rel="bookmark" class="title">《新编计算机科学概论》一本章小结</a>
					<div>
						本章小结 虚拟机的概念有助于我们正确理解计算机的实质和计算机运算的实现途径,从而更好地进行计算机语言的研究和应用,包括了从基础的硬件层到应用层的不同层次结构的虚拟机. 计算机能直接执行用机器语言所编的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgYo8M.html" rel="bookmark" class="title">路由器连接实例解析</a>
					<div>
						路由器连接设备用ADSL上网,有两个soho中小企业路由器连接,均4,已成功1分4,但目前有5户,即其中要第一个由出来后的一条线再进第二个由后再一分二,这种情况比较普遍,下面我们看一下路由器连接的原理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9x28Xb.html" rel="bookmark" class="title">php验证用户名是否以字母开头与验证密码实例&lowbar;正则表达式</a>
					<div>
						本文实例讲述了php验证用户名是否以字母开头与验证密码的方法.分享给大家供大家参考.具体如下: 验证用户名是否以字母开头与验证密码只能为数字和字母的组合代码,三种常用验证函数:验证邮箱地址格式 ,验证 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgP8KM.html" rel="bookmark" class="title">数据过滤器使用法则</a>
					<div>
						数据过滤器使用法则 相信很多企业版用户已经发现编辑器出现了一个新功能「数据过滤器」,然而打开这个功能之后,又不知道怎么用.今天我们就来简单入门一下这个新功能. 能干什么 「数据过滤器」可以算是「字段映 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xLVRb.html" rel="bookmark" class="title">fatal error c1902-vs2008-errrorr 数据库管理器不匹配</a>
					<div>
						问题描述 vs2008-errrorr 数据库管理器不匹配 大家使用VS2008的时候有没有遇到过这种问题呀!遇到的话请大神指点一下啊!之前编译还好好的,然后就是改了一下程序(也不是什么大改动)在编译 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeJ7JM.html" rel="bookmark" class="title">判定正则表达式为什么出错了呢。。。如图</a>
					<div>
						问题描述 解决方案 解决方案二:Stringregex=&quot;\p{Upper}\p{Lower}\p{Lower}\p{Lower}\d\d\d&quot;第二个p{Lower}少了个}解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jAXKp.html" rel="bookmark" class="title">google PR更新之我见</a>
					<div>
						很多迹象表明这次PR大规模更新,大量网站PR上升是没有根据的. 根本不符合PR值的原则! 很多业内人士都琢磨不透,那我就来胡乱猜一下:这次普遍PR值上升是google回光返照的表现! 大家都知道在国内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkVmvz.html" rel="bookmark" class="title">Android7&period;0 工具类：DiffUtil详解&lowbar;Android</a>
					<div>
						一 概述 DiffUtil是support-v7:24.2.0中的新工具类,它用来比较两个数据集,寻找出旧数据集-&gt;新数据集的最小变化量. 说到数据集,相信大家知道它是和谁相关的了,就是我的最爱 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0Enoz.html" rel="bookmark" class="title">ASP&period;NET&lpar;C&num;&rpar;中操作SQLite数据库实例&lowbar;实用技巧</a>
					<div>
						要想在ASP.NET项目中使用SQLite数据库,先需下载一个ADO.NET 2.0 SQLite Data Provider,下载地址为:http://sourceforge.net/project ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZDGwz.html" rel="bookmark" class="title">JS字符串截取函数实例&lowbar;javascript技巧</a>
					<div>
						使用 substring()或者slice() 函数:split() 功能:使用一个指定的分隔符把一个字符串分割存储到数组例子: 复制代码 代码如下: str=&quot;jpg|bmp|gif|ic ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
